#include <iostream>
#include <fstream>
#include <vector>
#include "spektaklis.h"
#include "rodymai.h"
#include <string>

using namespace std;

typedef std::vector<Spektaklis*> SpektSar;
typedef std::vector<Rodymai*>    RodymSar;
//------------------------------------------------------------------------------
Spektaklis* pasirinktSpekt(SpektSar& spektSar);
void spauzdintSpektSar(SpektSar& spektSar);
void itrauktNaujSpekt(SpektSar& spektSar);
void spektRodymas(SpektSar& spektSar, RodymSar& rodymSar);
void spektaklioInformacija(SpektSar& spektSar);
void laikotarpioUzdarbis(RodymSar& rodymSar);
void pelningSpekt(SpektSar spektSar);
void prasciausSpekt(SpektSar spektSar);
void isFailo(SpektSar&, RodymSar&);
//------------------------------------------------------------------------------
//==============================================================================
int main ()
{
    SpektSar spektSar;
    RodymSar rodymSar;
    for(;;)
    {
           cout << endl
                << "Teatro suvestine:"                  << endl
                << "1 - sarasas"                        << endl
                << "2 - itraukti spektakli"             << endl
                << "3 - itraukti rodyma"                << endl
                << "4 - spektaklio informacija"         << endl
                << "5 - pelningiausias spektaklis"      << endl
                << "6 - maziausiai uzdirbes spektaklis" << endl
                << "7 - laikotarpio pelnas"             << endl
		<< "8 - duomenu ivedimas is failo"	<< endl
                << endl
                << "0 - baigti darba"                   << endl;
           string klav;
           cin >> klav;
                if (klav == "0") return 0;
           else if (klav == "1") spauzdintSpektSar(spektSar);
           else if (klav == "2") itrauktNaujSpekt(spektSar);
           else if (klav == "3") spektRodymas(spektSar, rodymSar);
           else if (klav == "4") spektaklioInformacija(spektSar);
           else if (klav == "5") pelningSpekt(spektSar);
           else if (klav == "6") prasciausSpekt(spektSar);
           else if (klav == "7") laikotarpioUzdarbis(rodymSar);
           else if (klav == "8") isFailo(spektSar, rodymSar);
           else cout << endl << "Neteisinga komanda..." << endl;
    }
}
//==============================================================================
//------------------------------------------------------------------------------
Spektaklis* pasirinktSpekt(SpektSar& spektSar)
{
    for (;;)
    {
        string pavad;
        spauzdintSpektSar(spektSar);
        cout << "Pasirinkite spektakli ('$'-baigti): ";
        cin >> pavad;
        if (pavad == "$") return 0;
        SpektSar::iterator iter = spektSar.begin();
        for (; iter != spektSar.end(); iter++)
              if (pavad == (*iter)->getPavad()) return *iter;
    }
    return 0;
}
//------------------------------------------------------------------------------
void spauzdintSpektSar(SpektSar& spektSar)
{
     cout << "-- Spektakliu sarasas --" << endl;
     SpektSar::iterator iter = spektSar.begin();
     for (; iter != spektSar.end(); iter++)
         (*iter)->spauzdinti();
}
//------------------------------------------------------------------------------    
void itrauktNaujSpekt(SpektSar& spektSar)
{
     string pavad;
     cout << "Iveskite spektaklio pavadinima:";      cin >> pavad;
     spektSar.push_back(new Spektaklis(pavad));
}
//------------------------------------------------------------------------------ 
void spektRodymas(SpektSar& spektSar, RodymSar& rodymSar)
{
     cout << "--Spektakliu rodymai--" << endl;
     Spektaklis* spekt = pasirinktSpekt(spektSar);
     if (spekt == 0) return;
     string data;
     int    vietos;
     double uzdarbis;
     spekt->spauzdinti();
     cout << "rodymo data (yyyy.mm.dd): "; cin >> data;
     cout << "vietu skaicius: ";           cin >> vietos;
     cout << "uzdarbis litais: ";          cin >> uzdarbis;
     Rodymai* rodymas = new Rodymai(spekt, data, vietos, uzdarbis);
     spekt->pridetRodyma(rodymas);
     rodymSar.push_back(rodymas);
}
//------------------------------------------------------------------------------
void spektaklioInformacija(SpektSar& spektSar)
{
     cout << "--Spektakliu rodymo informacija--" << endl;
     Spektaklis* spekt = pasirinktSpekt(spektSar);
     if (spekt == 0) return;
     cout << "Spektaklio informacija:" << endl;
     spekt->spauzdinti();
     for (int i = 0; i < spekt->getRodymuSk(); i++)
         spekt->getRodymai(i)->spauzdint();
}
//------------------------------------------------------------------------------
void laikotarpioUzdarbis(RodymSar& rodymSar)
{
     string dataNuo, dataIki;
     cout << "--Laikotarpio teatro apyvarta--" << endl;
     cout << "nuo kada (yyyy.mm.dd): "; cin >> dataNuo;
     cout << "iki kada (yyyy.mm.dd): "; cin >> dataIki;
     double pelnas;
     RodymSar::iterator iter = rodymSar.begin();
     for (; iter != rodymSar.end(); iter++)
         if (dataNuo <= (*iter)->getData() && (*iter)->getData() <= dataIki)
         {
              (*iter)->spauzdint();
              pelnas += (*iter)->getUzdarbis();
         }
     cout << "laikotarpio pelnas: " << pelnas << endl;
}
//------------------------------------------------------------------------------
void pelningSpekt(SpektSar spektSar)
{
     double max = 0;
     Spektaklis* laikinas;
     cout << "-- Pelningiausias spektaklis --" << endl;
     SpektSar::iterator iter = spektSar.begin();
     for (; iter != spektSar.end(); iter++)
         if (max < (*iter)->spektPelnas())
         {
             max      = (*iter)->spektPelnas();
             laikinas = (*iter);
         };                     
     laikinas->spauzdinti();
}
//------------------------------------------------------------------------------
void prasciausSpekt(SpektSar spektSar)
{
     double min = 20000;
     Spektaklis* laikinas;
     cout << "-- Maziausiai uzdirbes spektaklis --" << endl;
     SpektSar::iterator iter = spektSar.begin();
     for (; iter != spektSar.end(); iter++)
         if (min > (*iter)->spektPelnas())
         {
             min   = (*iter)->spektPelnas();
             laikinas = (*iter);   
         };
     laikinas->spauzdinti();
}
void isFailo(SpektSar& spektSar, RodymSar& rodymSar)
{
     ifstream failas ("duom.txt");
     string pavad, data;
     Spektaklis* spekt;
     int         vietos, sk;
     double      uzdarbis;
     while (failas.good())
     {
           
	   getline (failas, pavad, '/');
	   if (!failas.good()) break;
	   spektSar.push_back(new Spektaklis(pavad));
	   failas >> sk;
	   failas.ignore();
	   for (int i = 0; i < sk; i++)
	   {
		failas >> data;
           	failas >> vietos;
           	failas >> uzdarbis;
	   	SpektSar::iterator iter = spektSar.begin();
           	for (; iter != spektSar.end(); iter++)
		    if (pavad == (*iter)->getPavad()) spekt = *iter;
           	Rodymai* rodymas = new Rodymai(spekt, data, vietos, uzdarbis);
           	spekt->pridetRodyma(rodymas);
           	rodymSar.push_back(rodymas);
		failas.ignore();
	   }
	   failas.ignore();
           //failas >> pavad;
     }
     failas.close();
}
